# This file is a template, and might need editing before it works on your project.
# Full project: https://gitlab.com/pages/plain-html

stages:
  - build
  - deploy


# ###########################
# Test Stage
# ###########################

# Run pytest + coverage and create html report (pytest_report.html)
# anaconda3:
#  image: continuumio/anaconda3
#  stage: test
#  script:
#    - pip install pytest pytest-cov pytest-html
#    - pip install -r requirements.txt
#    - pip install -e ".[all]"
#    - pip freeze
#    - export PYTHONPATH=$PWD
#    - pytest --cov=pyxel --cov-report= --cov-report=html --html=pytest_report.html --self-contained-html --color=yes --full-trace --showlocals --verbose
#    - coverage report > coverage.out
#  artifacts:
#    paths:
#      - htmlcov
#      - pytest_report.html
#      - coverage.out
#  allow_failure: false




# ###########################
# Build stage
# ###########################

# create badges
# badges:
#   image: python:3
#   stage: build
#   script:
#     - tail -n 1 coverage.out > cov_total.out
#     - PERCENT=$(awk '{printf "%.2f", ($2-$3)/$2*100}' cov_total.out)
#     - python badges.py -cov=$PERCENT
#     - ls
#   artifacts:
#     paths:
#       - coverage.svg
#   allow_failure: true

# Generate the Sphinx documentation into 'doc/html'
doc:
  image: python:3
  stage: build
  script:
    - pip install -r docs/requirements-docs.txt
    - pip install -e ".[all]"
#    - pip install doc8
    - export PYTHONPATH=$PWD
#    - doc8 docs/source
    - sphinx-build docs/source docs/html -E -a -j 4
#    - python badges.py -doc="passed"
  artifacts:
    paths:
      - docs/html
      - documentation.svg
  allow_failure: false

# ###########################
# Deploy stage
# ###########################

# Moving the generated documentation to the gitlab pages
pages:
  image: python:3
  stage: deploy
  script:
  - mkdir public
  - ls -l docs/html/*
  - mv docs/html/* public
  - ls -l public/*
  artifacts:
    paths:
    - public
#  only:
#  - master